package com.google;

import edu.stanford.nlp.simple.Sentence;
import edu.stanford.nlp.simple.Token;
import io.whelk.flesch.kincaid.PennTreebankValidator;
import io.whelk.flesch.kincaid.ReadabilityCalculator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

class Readability {
    private final static String DEFAULT_COLOR = "#999999";
    private static final int UNDEFINED_CONSTANT = 1000;

    /*List<String> colors = ["#cc3300", "#ff9966", "#ffcc00", "#99cc33", "#339900"]; //red to green
    List<Double> spreadReadingEase = [20, 40, 60, 80, 100];
    List<Double> spreadGradeLevel = [15, 12, 10, 7, 0];
*/
    Readability() {
    }

   /* Readability(List<Double> readingEaseSpread, List<Double> gradeLevelSpread, List<String> listOfColors) {
        if (readingEaseSpread.size() == listOfColors.size()) {
            spreadReadingEase = readingEaseSpread;
            colors = listOfColors;
        } else {
            throw new Exception("The size of the color list is not the same as size of list for readingEase spread");
        }

        if (listOfColors.size() == listOfColors.size()) {
            spreadGradeLevel = gradeLevelSpread;
        } else {
            throw new Exception("The size of the color list is not the same as size of list for gradeLevel spread");
        }
    }*/

    /*String getReadingEaseColor(Number readingEase) { // Number to accommodate double as well as decimal data types
        if (readingEase == null || readingEase == UNDEFINED_CONSTANT) {
            return DEFAULT_COLOR
        }
        for (int i = 0; i < colors.size(); i++) {
            if (readingEase < spreadReadingEase.get(i)) {
                return colors.get(i)
            }
        }
        return colors.get(colors.size() - 1)
    }*/

    /*String getGradeLevelColor(Number gradeLevel) {// Number to accommodate double as well as decimal data types
        if (gradeLevel == null || gradeLevel == UNDEFINED_CONSTANT) {
            return DEFAULT_COLOR
        }
        for (int i = 0; i < colors.size(); i++) {
            if (gradeLevel > spreadGradeLevel.get(i)) {
                return colors.get(i)
            }
        }
        return colors.get(colors.size() - 1)
    }*/

    /*static void fillInReadability(Document block, int minNumberOfWords) {
        String blockText = Variables.expandVariables(block);
        int count = 0

        for (Long vector in block.longestCommonSequenceVector) {
            if (Vocabulary.isAlphaNumerical(vector)) {
                count++
            }
        }

        if (count > minNumberOfWords) {
            def (readingEaseTemplate, gradeLevelTemplate) = calculateMetrics(blockText);
            block.put("ReadingEase", readingEaseTemplate)
            block.put("GradeLevel", gradeLevelTemplate)
        } else {
            block.put("ReadingEase", UNDEFINED_CONSTANT)
            block.put("GradeLevel", UNDEFINED_CONSTANT)
        }
    }*/

    /*static void fillInTemplateReadability(Document template, String collectionName, boolean cloud) {
        List values = Documents.decomposeFinalSequence(template.get("finalSequence"))
        List<String> blocksInCalculation = values.collect { name -> return name.value }

        MongoCollection<Document> collectionBlocks = ConnectionFactory.CONNECTION.getCollection(DatabaseEnum.BLOCKS, collectionName, cloud);
        FindIterable<Document> blocksField = collectionBlocks.find(and(Filters.in("OriginalBlockName", blocksInCalculation), eq("Active", "true"))).projection(exclude("parentList", "textFromVector", "longestCommonSequence", "BlockTemplateVector"))

        StringBuilder wholeDocument = new StringBuilder();
        for (Document it in blocksField) {
            wholeDocument.append(" ").append(Variables.expandVariables(it));
        }

        def (readingEaseTemplate, gradeLevelTemplate) = calculateMetrics(wholeDocument.toString());

        template.put("ReadingEase", readingEaseTemplate)
        template.put("GradeLevel", gradeLevelTemplate)
    }*/

    public static List calculateMetrics(String content) {
        List<Sentence> sentences = tokenizeContent(content);
        List<String> words = tokenizeSentences(sentences);
        int readingEaseTemplate = (int) Math.round(ReadabilityCalculator.calculateReadingEase(sentences, words));
        int gradeLevelTemplate = (int) Math.round(ReadabilityCalculator.calculateGradeLevel(sentences, words));
        List<Integer> values = new ArrayList();
        values.add(readingEaseTemplate);
        values.add(gradeLevelTemplate);
        return values;
    }

    public static String getEducationLevel(List<Integer> readability){
        int readingEase = readability.get(0);
        int gradeLevel = readability.get(1);

        int readingEaseNum = -1;
        int gradeLevelNum = -1;

        if(readingEase > 90){
            readingEaseNum = 0;
        }
        else if(readingEase > 60){
            readingEaseNum = 1;
        }
        else if(readingEase > 30){
            readingEaseNum = 2;
        }
        else {
            readingEaseNum = 3;
        }

        if(gradeLevel < 6){
            gradeLevelNum = 0;
        }
        else if(gradeLevel < 8){
            gradeLevelNum = 1;
        }
        else if(gradeLevel < 12){
            gradeLevelNum = 2;
        }
        else {
            gradeLevelNum = 3;
        }

        int result = Math.round((readingEaseNum + gradeLevelNum) / 2);
        String[] schoolLevel = {"Elementary", "Middle", "High", "University"};

        return schoolLevel[result];

    }

    private static List<Sentence> tokenizeContent(String content) {
        return content != null ? (new edu.stanford.nlp.simple.Document(content)).sentences() : Collections.emptyList();
    }

    private static List<String> tokenizeSentences(List<Sentence> sentences) {
        return sentences != null ? (List)sentences.stream().map(Sentence::tokens).flatMap(Collection::stream).filter(PennTreebankValidator::isWord).map(Token::originalText).collect(Collectors.toList()) : Collections.emptyList();

    }
}
